/****************************************************************************
** Class DialogLibrary
**
**   Created : Sun Feb 18 09:13:25 2007
**        by : Varol Okan, using XEmaxs
** Copyright : (c) Varol Okan
**   License : GPL v 2.0
**
**
****************************************************************************/

#ifndef DIALOGLIBRARY_H
#define DIALOGLIBRARY_H

#include <qvaluelist.h>

#include "uidialoglibrary.h"

class QIconView;

class DialogLibrary : public uiDialogLibrary
{
    Q_OBJECT
    
    class LibraryPart {
    public:
      LibraryPart ( QIconView *, QString );
      QIconView *pIconView;
      QString    qsLibraryPath;
    };

public:
   DialogLibrary ( QWidget *p=0, const char *n=NULL, bool m=FALSE, WFlags f=0 );
  ~DialogLibrary ( );

  void initMe    ( );
  void createTab ( QString, QString, QStringList & );

  static bool m_bCreateButtonMask;

protected:
  void setTransparentColor ( QImage & );

protected slots:
  virtual void accept        ( );
  virtual void slotRefresh   ( );
  virtual void slotChecked   ( );
  virtual void slotAfterInit ( );

private:
  int m_iWidth;
  int m_iHeight;
  QValueList<LibraryPart *>  m_listLibrary;
};

#endif // DIALOGLIBRARY_H
