/****************************************************************************
** Interface to the GUI.
**
**   Created : Thu Mar 03 12:09:08 2004
**        by : Varol Okan using kate editor
** Copyright : (c) Varol Okan
**   License : GPL v 2.0
**
** This class re-implements the QListBoxText class and adds a background
** color to it.
**
****************************************************************************/

#ifndef LISTBOXCOLORTEXT_H
#define LISTBOXCOLORTEXT_H

#include <qlistbox.h>

class ListBoxColorText : public QListBoxText
{
public:
	ListBoxColorText (const QString &, const QColor &);
	virtual ~ListBoxColorText ();

protected:
	virtual void paint (QPainter *);
	virtual int width (const QListBox *);

private:
	QColor m_backgroundColor;
};

#endif // LISTBOXCOLORTEXT_H
