/****************************************************************************
** Interface to the GUI.
**
** Created: Tue Dec 14 22:48:00 2004
**      by: Varol Okan using kate editor
**
**
****************************************************************************/

#ifndef DIALOGMPLAYERSETUP_H
#define DIALOGMPLAYERSETUP_H

#include "uidialogmplayersetup.h"

class QProcess;
class QStringList;

class DialogMPlayerSetup : public uiDialogMPlayerSetup
{
	Q_OBJECT
public:
	         DialogMPlayerSetup (QWidget *, const char *n=0, WFlags f=0);
	virtual ~DialogMPlayerSetup ();

	void initMe(QStringList *);
protected slots:
	// This slot will retrieve the supported video / audio plugins
	virtual void slotProcessVideoPlugins ();
	virtual void slotProcessAudioPlugins ();

private:	// Private member functions
	void killProcesses ();

private:	// Private member variables
	QProcess    *m_pVideoProcess;
	QProcess    *m_pAudioProcess;
	
	QStringList *m_pListPluginOptions;
};

#endif // DIALOGMPLAYERSETUP_H
