/****************************************************************************
** Form interface generated from reading ui file 'smalldialogaudio.ui'
**
**   Created : Mon Jan 29 21:19:48 2007
**        by : Varol Okan, using XEmacs and designer
** Copyright : (c) Varol Okan
** License   : GPL v 2.0
**
****************************************************************************/

#ifndef SMALLDIALOGAUDIO_H
#define SMALLDIALOGAUDIO_H

#include <qvariant.h>
#include <qdialog.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class QComboBox;
class QGroupBox;
class QCheckBox;
class QLabel;
class QPushButton;

//#include "sourcefileentry.h"
class TranscodeInterface;
class SourceFileEntry;
class SourceFileInfo;
class Audio;

class SmallDialogAudio : public QDialog
{
    Q_OBJECT

public:
     SmallDialogAudio( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~SmallDialogAudio();

    void initMe ( Audio * );
    void initMe ( SourceFileEntry *, bool b=true );
    void setLanguageText ( QString & );
    QString languageText ( );

protected slots:
    virtual void accept                ( );
    virtual void slotHelp              ( );
    virtual void languageChange        ( );
    virtual void slotAudioLanguage     ( );
    virtual void slotTranscoding       ( bool );
    virtual void slotAudioEntryChanged (  int );
    
private:
    void initAudioInfo  ( Audio              *  );
    void initAudioInfo  ( SourceFileInfo     *  );
    void setTranscoding ( Audio              *  );
    void setTranscoding ( SourceFileInfo     *  );
    void setTranscoding ( TranscodeInterface *& );
    void initTranscode  ( TranscodeInterface *  );

private:
    SourceFileEntry *m_pSourceFileEntry;
    SourceFileEntry *m_pOrigSourceFileEntry;
    SourceFileInfo  *m_pPreviousSourceFileInfo;
    Audio           *m_pAudio;

    // Dialog widgets'n stuff
    QLabel* textLabel1;
    QLabel* m_pLabelLanguage;
    QComboBox* m_pComboAudioEntry;
    QGroupBox* m_pGroupAudioFile;
    QCheckBox* m_pCheckEnable;
    QGroupBox* m_pGroupAudio;
    QLabel* textLabel1_6_4_2;
    QLabel* textLabel1_6_4;
    QLabel* textLabel1_6_4_2_2;
    QLabel* textLabel1_2_3_4_2;
    QComboBox* m_pComboAudioOut;
    QComboBox* m_pComboAudioSampleRate;
    QComboBox* m_pComboAudioType;
    QComboBox* m_pComboAudioBitrate;
    QPushButton* m_pButtonLanguage;
    QPushButton* m_pButtonHelp;
    QPushButton* m_pButtonOk;
    QPushButton* m_pButtonCancel;

protected:
    QVBoxLayout* SmallDialogAudioLayout;
    QSpacerItem* spacer5;
    QHBoxLayout* layout9;
    QGridLayout* m_pGroupAudioFileLayout;
    QVBoxLayout* layout21;
    QHBoxLayout* m_pGroupAudioLayout;
    QVBoxLayout* layout47;
    QVBoxLayout* layout29;
    QVBoxLayout* layout31;
    QVBoxLayout* layout48;
    QVBoxLayout* layout30;
    QVBoxLayout* layout32;
    QGridLayout* layout9_2;
};

#endif // SMALLDIALOGAUDIO_H
